// A Bison parser, made by GNU Bison 3.7.5.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "Parser.hh"


// Unqualified %code blocks.
#line 48 "Parser.yy"

#include "Driver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex


#line 57 "Parser.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "Parser.yy"
namespace Tokenizer {
#line 150 "Parser.cc"

  /// Build a parser object.
  parser::parser (macro::Driver &driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.copy< DirectivePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.copy< ExpressionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function: // function
        value.copy< FunctionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol: // symbol
        value.copy< VariablePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.copy< pair<ExpressionPtr, vector<DirectivePtr>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.copy< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.copy< vector<ExpressionPtr> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.copy< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_name_list: // name_list
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.move< DirectivePtr > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.move< ExpressionPtr > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function: // function
        value.move< FunctionPtr > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_symbol: // symbol
        value.move< VariablePtr > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.move< pair<ExpressionPtr, vector<DirectivePtr>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.move< string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.move< vector<ExpressionPtr> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.move< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_name_list: // name_list
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.YY_MOVE_OR_COPY< DirectivePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.YY_MOVE_OR_COPY< ExpressionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function: // function
        value.YY_MOVE_OR_COPY< FunctionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol: // symbol
        value.YY_MOVE_OR_COPY< VariablePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.YY_MOVE_OR_COPY< pair<ExpressionPtr, vector<DirectivePtr>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.YY_MOVE_OR_COPY< vector<ExpressionPtr> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.YY_MOVE_OR_COPY< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_name_list: // name_list
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.move< DirectivePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.move< ExpressionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function: // function
        value.move< FunctionPtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol: // symbol
        value.move< VariablePtr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.move< pair<ExpressionPtr, vector<DirectivePtr>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.move< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.move< vector<ExpressionPtr> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.move< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_name_list: // name_list
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.copy< DirectivePtr > (that.value);
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.copy< ExpressionPtr > (that.value);
        break;

      case symbol_kind::S_function: // function
        value.copy< FunctionPtr > (that.value);
        break;

      case symbol_kind::S_symbol: // symbol
        value.copy< VariablePtr > (that.value);
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.copy< pair<ExpressionPtr, vector<DirectivePtr>> > (that.value);
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.copy< string > (that.value);
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.copy< vector<ExpressionPtr> > (that.value);
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.copy< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (that.value);
        break;

      case symbol_kind::S_name_list: // name_list
        value.copy< vector<string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        value.move< DirectivePtr > (that.value);
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        value.move< ExpressionPtr > (that.value);
        break;

      case symbol_kind::S_function: // function
        value.move< FunctionPtr > (that.value);
        break;

      case symbol_kind::S_symbol: // symbol
        value.move< VariablePtr > (that.value);
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        value.move< pair<ExpressionPtr, vector<DirectivePtr>> > (that.value);
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        value.move< string > (that.value);
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        value.move< vector<ExpressionPtr> > (that.value);
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        value.move< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (that.value);
        break;

      case symbol_kind::S_name_list: // name_list
        value.move< vector<string> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 38 "Parser.yy"
{
  // Initialize the location filenames
  yyla.location.begin.filename = yyla.location.end.filename = &driver.file;
}

#line 848 "Parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_statement: // statement
      case symbol_kind::S_directive: // directive
      case symbol_kind::S_directive_one_line: // directive_one_line
      case symbol_kind::S_directive_multiline: // directive_multiline
      case symbol_kind::S_for: // for
      case symbol_kind::S_if: // if
      case symbol_kind::S_ifdef: // ifdef
      case symbol_kind::S_ifndef: // ifndef
      case symbol_kind::S_text: // text
      case symbol_kind::S_eval: // eval
        yylhs.value.emplace< DirectivePtr > ();
        break;

      case symbol_kind::S_for_when: // for_when
      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_oper_expr: // oper_expr
      case symbol_kind::S_colon_expr: // colon_expr
      case symbol_kind::S_expr: // expr
        yylhs.value.emplace< ExpressionPtr > ();
        break;

      case symbol_kind::S_function: // function
        yylhs.value.emplace< FunctionPtr > ();
        break;

      case symbol_kind::S_symbol: // symbol
        yylhs.value.emplace< VariablePtr > ();
        break;

      case symbol_kind::S_elseif: // elseif
      case symbol_kind::S_else: // else
        yylhs.value.emplace< pair<ExpressionPtr, vector<DirectivePtr>> > ();
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_TEXT: // TEXT
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_NUMBER: // NUMBER
      case symbol_kind::S_EOL: // EOL
        yylhs.value.emplace< string > ();
        break;

      case symbol_kind::S_function_args: // function_args
      case symbol_kind::S_comma_expr: // comma_expr
      case symbol_kind::S_tuple_comma_expr: // tuple_comma_expr
        yylhs.value.emplace< vector<ExpressionPtr> > ();
        break;

      case symbol_kind::S_if_list: // if_list
      case symbol_kind::S_if_list1: // if_list1
        yylhs.value.emplace< vector<pair<ExpressionPtr, vector<DirectivePtr>>> > ();
        break;

      case symbol_kind::S_name_list: // name_list
        yylhs.value.emplace< vector<string> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // statements: statement
#line 110 "Parser.yy"
             {
               driver.inContext() ? driver.pushContextTop(yystack_[0].value.as < DirectivePtr > ()) : driver.pushStatements(yystack_[0].value.as < DirectivePtr > ());
             }
#line 1044 "Parser.cc"
    break;

  case 3: // statements: statements statement
#line 114 "Parser.yy"
             {
               driver.inContext() ? driver.pushContextTop(yystack_[0].value.as < DirectivePtr > ()) : driver.pushStatements(yystack_[0].value.as < DirectivePtr > ());
             }
#line 1052 "Parser.cc"
    break;

  case 4: // statement: directive
#line 119 "Parser.yy"
            { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1058 "Parser.cc"
    break;

  case 5: // statement: text
#line 120 "Parser.yy"
            { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1064 "Parser.cc"
    break;

  case 6: // statement: eval
#line 121 "Parser.yy"
            { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1070 "Parser.cc"
    break;

  case 7: // directive: directive_one_line EOL
#line 124 "Parser.yy"
            { yylhs.value.as < DirectivePtr > () = yystack_[1].value.as < DirectivePtr > (); }
#line 1076 "Parser.cc"
    break;

  case 8: // directive: directive_multiline EOL
#line 125 "Parser.yy"
            { yylhs.value.as < DirectivePtr > () = yystack_[1].value.as < DirectivePtr > (); }
#line 1082 "Parser.cc"
    break;

  case 9: // directive_one_line: INCLUDE expr
#line 129 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<Include>(yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1088 "Parser.cc"
    break;

  case 10: // directive_one_line: INCLUDEPATH expr
#line 131 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<IncludePath>(yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1094 "Parser.cc"
    break;

  case 11: // directive_one_line: DEFINE symbol
#line 133 "Parser.yy"
                     {
                       auto tmp = make_shared<Real>("1", yylhs.location);
                       yylhs.value.as < DirectivePtr > () = make_shared<Define>(yystack_[0].value.as < VariablePtr > (), tmp, yylhs.location);
                     }
#line 1103 "Parser.cc"
    break;

  case 12: // directive_one_line: DEFINE symbol EQUAL expr
#line 138 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<Define>(yystack_[2].value.as < VariablePtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1109 "Parser.cc"
    break;

  case 13: // directive_one_line: DEFINE function EQUAL expr
#line 140 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<Define>(yystack_[2].value.as < FunctionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1115 "Parser.cc"
    break;

  case 14: // directive_one_line: D_ECHO expr
#line 142 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<Echo>(yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1121 "Parser.cc"
    break;

  case 15: // directive_one_line: ERROR expr
#line 144 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<Error>(yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1127 "Parser.cc"
    break;

  case 16: // directive_one_line: ECHOMACROVARS
#line 146 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<EchoMacroVars>(false, yylhs.location); }
#line 1133 "Parser.cc"
    break;

  case 17: // directive_one_line: ECHOMACROVARS name_list
#line 148 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<EchoMacroVars>(false, yystack_[0].value.as < vector<string> > (), yylhs.location); }
#line 1139 "Parser.cc"
    break;

  case 18: // directive_one_line: ECHOMACROVARS LPAREN SAVE RPAREN
#line 150 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<EchoMacroVars>(true, yylhs.location); }
#line 1145 "Parser.cc"
    break;

  case 19: // directive_one_line: ECHOMACROVARS LPAREN SAVE RPAREN name_list
#line 152 "Parser.yy"
                     { yylhs.value.as < DirectivePtr > () = make_shared<EchoMacroVars>(true, yystack_[0].value.as < vector<string> > (), yylhs.location); }
#line 1151 "Parser.cc"
    break;

  case 20: // directive_one_line: LINE QUOTED_STRING NUMBER
#line 154 "Parser.yy"
                     {
                       // `@#line` is ignored; adjust newlines in output to accord
                       auto l = static_cast<Tokenizer::parser::location_type>(yylhs.location);
                       yylhs.value.as < DirectivePtr > () = make_shared<TextNode>(string(l.end.line - l.begin.line + 1, '\n'), yylhs.location);
                     }
#line 1161 "Parser.cc"
    break;

  case 21: // name_list: NAME
#line 162 "Parser.yy"
            { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 1167 "Parser.cc"
    break;

  case 22: // name_list: name_list NAME
#line 164 "Parser.yy"
            {
              yystack_[1].value.as < vector<string> > ().emplace_back(yystack_[0].value.as < string > ());
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
            }
#line 1176 "Parser.cc"
    break;

  case 23: // directive_multiline: for
#line 170 "Parser.yy"
                      { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1182 "Parser.cc"
    break;

  case 24: // directive_multiline: if
#line 171 "Parser.yy"
                      { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1188 "Parser.cc"
    break;

  case 25: // directive_multiline: ifdef
#line 172 "Parser.yy"
                      { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1194 "Parser.cc"
    break;

  case 26: // directive_multiline: ifndef
#line 173 "Parser.yy"
                      { yylhs.value.as < DirectivePtr > () = yystack_[0].value.as < DirectivePtr > (); }
#line 1200 "Parser.cc"
    break;

  case 27: // for_when: %empty
#line 177 "Parser.yy"
           { yylhs.value.as < ExpressionPtr > () = shared_ptr<Expression>(); }
#line 1206 "Parser.cc"
    break;

  case 28: // for_when: WHEN expr
#line 179 "Parser.yy"
           { yylhs.value.as < ExpressionPtr > () = yystack_[0].value.as < ExpressionPtr > (); }
#line 1212 "Parser.cc"
    break;

  case 29: // $@1: %empty
#line 182 "Parser.yy"
          { driver.pushContext(); }
#line 1218 "Parser.cc"
    break;

  case 30: // for: FOR $@1 expr IN expr for_when EOL statements ENDFOR
#line 183 "Parser.yy"
      {
        vector<VariablePtr> vvnp;
        auto tmpt = dynamic_pointer_cast<Tuple>(yystack_[6].value.as < ExpressionPtr > ());
        auto tmpv = dynamic_pointer_cast<Variable>(yystack_[6].value.as < ExpressionPtr > ());
        if (tmpv)
          vvnp.emplace_back(tmpv);
        else if (tmpt)
          for (const auto & it : tmpt->getValue())
            {
              auto vnp = dynamic_pointer_cast<Variable>(it);
              if (!vnp)
                error(yylhs.location, "For loop indices must be variables");
              vvnp.emplace_back(vnp);
            }
        else
          error(yystack_[8].location, "For loop indices must be a variable or a tuple");

        auto vdp = driver.popContext();
        vdp.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));

        if (!yystack_[3].value.as < ExpressionPtr > ())
          yylhs.value.as < DirectivePtr > () = make_shared<For>(vvnp, yystack_[4].value.as < ExpressionPtr > (), vdp, yylhs.location);
        else
          {
            auto tmpc = make_shared<Comprehension>(true, yystack_[6].value.as < ExpressionPtr > (), yystack_[4].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[3].location);
            yylhs.value.as < DirectivePtr > () = make_shared<For>(vvnp, tmpc, vdp, yylhs.location);
          }
      }
#line 1251 "Parser.cc"
    break;

  case 31: // $@2: %empty
#line 213 "Parser.yy"
        { driver.pushContext(); }
#line 1257 "Parser.cc"
    break;

  case 32: // if: IF $@2 if_list ENDIF
#line 214 "Parser.yy"
     { yylhs.value.as < DirectivePtr > () = make_shared<If>(yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (), yylhs.location); }
#line 1263 "Parser.cc"
    break;

  case 33: // $@3: %empty
#line 217 "Parser.yy"
              { driver.pushContext(); }
#line 1269 "Parser.cc"
    break;

  case 34: // ifdef: IFDEF $@3 if_list ENDIF
#line 218 "Parser.yy"
        { yylhs.value.as < DirectivePtr > () = make_shared<Ifdef>(yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (), yylhs.location); }
#line 1275 "Parser.cc"
    break;

  case 35: // $@4: %empty
#line 221 "Parser.yy"
                { driver.pushContext(); }
#line 1281 "Parser.cc"
    break;

  case 36: // ifndef: IFNDEF $@4 if_list ENDIF
#line 222 "Parser.yy"
         { yylhs.value.as < DirectivePtr > () = make_shared<Ifndef>(yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (), yylhs.location); }
#line 1287 "Parser.cc"
    break;

  case 37: // if_list: if_list1
#line 225 "Parser.yy"
          { yylhs.value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > () = yystack_[0].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > (); }
#line 1293 "Parser.cc"
    break;

  case 38: // if_list: if_list1 else
#line 227 "Parser.yy"
          {
            yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > ().emplace_back(yystack_[0].value.as < pair<ExpressionPtr, vector<DirectivePtr>> > ());
            yylhs.value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > () = yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > ();
          }
#line 1302 "Parser.cc"
    break;

  case 39: // if_list1: expr EOL
#line 234 "Parser.yy"
           {
             auto context = driver.popContext();
             context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
             yylhs.value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > () = {{yystack_[1].value.as < ExpressionPtr > (), context}};
           }
#line 1312 "Parser.cc"
    break;

  case 40: // if_list1: expr EOL statements
#line 240 "Parser.yy"
           {
             auto context = driver.popContext();
             context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
             yylhs.value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > () = {{yystack_[2].value.as < ExpressionPtr > (), context}};
           }
#line 1322 "Parser.cc"
    break;

  case 41: // if_list1: if_list1 elseif
#line 246 "Parser.yy"
           {
             yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > ().emplace_back(yystack_[0].value.as < pair<ExpressionPtr, vector<DirectivePtr>> > ());
             yylhs.value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > () = yystack_[1].value.as < vector<pair<ExpressionPtr, vector<DirectivePtr>>> > ();
           }
#line 1331 "Parser.cc"
    break;

  case 42: // elseif_begin: ELSEIF
#line 252 "Parser.yy"
                      { driver.pushContext(); }
#line 1337 "Parser.cc"
    break;

  case 43: // elseif: elseif_begin expr EOL
#line 255 "Parser.yy"
         {
           auto context = driver.popContext();
           context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
           yylhs.value.as < pair<ExpressionPtr, vector<DirectivePtr>> > () = {yystack_[1].value.as < ExpressionPtr > (), context};
         }
#line 1347 "Parser.cc"
    break;

  case 44: // elseif: elseif_begin expr EOL statements
#line 261 "Parser.yy"
         {
           auto context = driver.popContext();
           context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
           yylhs.value.as < pair<ExpressionPtr, vector<DirectivePtr>> > () = {yystack_[2].value.as < ExpressionPtr > (), context};
         }
#line 1357 "Parser.cc"
    break;

  case 45: // else_begin: ELSE
#line 268 "Parser.yy"
                  { driver.pushContext(); }
#line 1363 "Parser.cc"
    break;

  case 46: // else: else_begin EOL
#line 271 "Parser.yy"
       {
         auto context = driver.popContext();
         context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
         yylhs.value.as < pair<ExpressionPtr, vector<DirectivePtr>> > () = {make_shared<Bool>(true, yystack_[1].location), context};
       }
#line 1373 "Parser.cc"
    break;

  case 47: // else: else_begin EOL statements
#line 277 "Parser.yy"
       {
         auto context = driver.popContext();
         context.emplace_back(make_shared<TextNode>("\n", yystack_[0].location));
         yylhs.value.as < pair<ExpressionPtr, vector<DirectivePtr>> > () = {make_shared<Bool>(true, yystack_[2].location), context};
       }
#line 1383 "Parser.cc"
    break;

  case 48: // text: TEXT
#line 285 "Parser.yy"
       { yylhs.value.as < DirectivePtr > () = make_shared<TextNode>(yystack_[0].value.as < string > (), yylhs.location); }
#line 1389 "Parser.cc"
    break;

  case 49: // text: EOL
#line 287 "Parser.yy"
       { yylhs.value.as < DirectivePtr > () = make_shared<TextNode>(yystack_[0].value.as < string > (), yylhs.location); }
#line 1395 "Parser.cc"
    break;

  case 50: // eval: BEGIN_EVAL expr END_EVAL
#line 291 "Parser.yy"
       { yylhs.value.as < DirectivePtr > () = make_shared<Eval>(yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1401 "Parser.cc"
    break;

  case 51: // symbol: NAME
#line 295 "Parser.yy"
         { yylhs.value.as < VariablePtr > () = make_shared<Variable>(yystack_[0].value.as < string > (), yylhs.location); }
#line 1407 "Parser.cc"
    break;

  case 52: // function: NAME LPAREN RPAREN
#line 299 "Parser.yy"
           { yylhs.value.as < FunctionPtr > () = make_shared<Function>(yystack_[2].value.as < string > (), vector<ExpressionPtr>(), yylhs.location); }
#line 1413 "Parser.cc"
    break;

  case 53: // function: NAME LPAREN function_args RPAREN
#line 301 "Parser.yy"
           { yylhs.value.as < FunctionPtr > () = make_shared<Function>(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<ExpressionPtr> > (), yylhs.location); }
#line 1419 "Parser.cc"
    break;

  case 54: // function_args: symbol
#line 305 "Parser.yy"
                { yylhs.value.as < vector<ExpressionPtr> > () = {yystack_[0].value.as < VariablePtr > ()}; }
#line 1425 "Parser.cc"
    break;

  case 55: // function_args: function_args COMMA symbol
#line 307 "Parser.yy"
                { yystack_[2].value.as < vector<ExpressionPtr> > ().emplace_back(yystack_[0].value.as < VariablePtr > ()); yylhs.value.as < vector<ExpressionPtr> > () = yystack_[2].value.as < vector<ExpressionPtr> > (); }
#line 1431 "Parser.cc"
    break;

  case 56: // comma_expr: %empty
#line 311 "Parser.yy"
             { yylhs.value.as < vector<ExpressionPtr> > () = {}; }
#line 1437 "Parser.cc"
    break;

  case 57: // comma_expr: expr
#line 313 "Parser.yy"
             { yylhs.value.as < vector<ExpressionPtr> > () = {yystack_[0].value.as < ExpressionPtr > ()}; }
#line 1443 "Parser.cc"
    break;

  case 58: // comma_expr: comma_expr COMMA expr
#line 315 "Parser.yy"
             { yystack_[2].value.as < vector<ExpressionPtr> > ().emplace_back(yystack_[0].value.as < ExpressionPtr > ()); yylhs.value.as < vector<ExpressionPtr> > () = yystack_[2].value.as < vector<ExpressionPtr> > (); }
#line 1449 "Parser.cc"
    break;

  case 59: // tuple_comma_expr: %empty
#line 319 "Parser.yy"
                   { yylhs.value.as < vector<ExpressionPtr> > () = {}; }
#line 1455 "Parser.cc"
    break;

  case 60: // tuple_comma_expr: expr COMMA
#line 321 "Parser.yy"
                   { yylhs.value.as < vector<ExpressionPtr> > () = {yystack_[1].value.as < ExpressionPtr > ()}; }
#line 1461 "Parser.cc"
    break;

  case 61: // tuple_comma_expr: expr COMMA expr
#line 323 "Parser.yy"
                   { yylhs.value.as < vector<ExpressionPtr> > () = {yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > ()}; }
#line 1467 "Parser.cc"
    break;

  case 62: // tuple_comma_expr: tuple_comma_expr COMMA expr
#line 325 "Parser.yy"
                   { yystack_[2].value.as < vector<ExpressionPtr> > ().emplace_back(yystack_[0].value.as < ExpressionPtr > ()); yylhs.value.as < vector<ExpressionPtr> > () = yystack_[2].value.as < vector<ExpressionPtr> > (); }
#line 1473 "Parser.cc"
    break;

  case 63: // primary_expr: LPAREN expr RPAREN
#line 329 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = yystack_[1].value.as < ExpressionPtr > (); }
#line 1479 "Parser.cc"
    break;

  case 64: // primary_expr: symbol
#line 331 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = yystack_[0].value.as < VariablePtr > (); }
#line 1485 "Parser.cc"
    break;

  case 65: // primary_expr: NAME LBRACKET comma_expr RBRACKET
#line 333 "Parser.yy"
               {
                 yylhs.value.as < ExpressionPtr > () = make_shared<Variable>(yystack_[3].value.as < string > (), make_shared<Array>(yystack_[1].value.as < vector<ExpressionPtr> > (), yystack_[1].location), yylhs.location);
               }
#line 1493 "Parser.cc"
    break;

  case 66: // primary_expr: NAME LPAREN comma_expr RPAREN
#line 337 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Function>(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<ExpressionPtr> > (), yylhs.location); }
#line 1499 "Parser.cc"
    break;

  case 67: // primary_expr: TRUE
#line 339 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Bool>(true, yylhs.location); }
#line 1505 "Parser.cc"
    break;

  case 68: // primary_expr: FALSE
#line 341 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Bool>(false, yylhs.location); }
#line 1511 "Parser.cc"
    break;

  case 69: // primary_expr: NUMBER
#line 343 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Real>(yystack_[0].value.as < string > (), yylhs.location); }
#line 1517 "Parser.cc"
    break;

  case 70: // primary_expr: QUOTED_STRING
#line 345 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<String>(yystack_[0].value.as < string > (), yylhs.location); }
#line 1523 "Parser.cc"
    break;

  case 71: // primary_expr: LBRACKET comma_expr RBRACKET
#line 347 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Array>(yystack_[1].value.as < vector<ExpressionPtr> > (), yylhs.location); }
#line 1529 "Parser.cc"
    break;

  case 72: // primary_expr: LPAREN tuple_comma_expr RPAREN
#line 349 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Tuple>(yystack_[1].value.as < vector<ExpressionPtr> > (), yylhs.location); }
#line 1535 "Parser.cc"
    break;

  case 73: // primary_expr: LBRACKET expr IN expr WHEN expr RBRACKET
#line 351 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Comprehension>(true, yystack_[5].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1541 "Parser.cc"
    break;

  case 74: // primary_expr: LBRACKET expr FOR expr IN expr RBRACKET
#line 353 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Comprehension>(yystack_[5].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1547 "Parser.cc"
    break;

  case 75: // primary_expr: LBRACKET expr FOR expr IN expr WHEN expr RBRACKET
#line 355 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<Comprehension>(yystack_[7].value.as < ExpressionPtr > (), yystack_[5].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1553 "Parser.cc"
    break;

  case 76: // primary_expr: LENGTH LPAREN expr RPAREN
#line 357 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::length, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1559 "Parser.cc"
    break;

  case 77: // primary_expr: ISEMPTY LPAREN expr RPAREN
#line 359 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::isempty, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1565 "Parser.cc"
    break;

  case 78: // primary_expr: ISBOOLEAN LPAREN expr RPAREN
#line 361 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::isboolean, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1571 "Parser.cc"
    break;

  case 79: // primary_expr: ISREAL LPAREN expr RPAREN
#line 363 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::isreal, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1577 "Parser.cc"
    break;

  case 80: // primary_expr: ISSTRING LPAREN expr RPAREN
#line 365 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::isstring, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1583 "Parser.cc"
    break;

  case 81: // primary_expr: ISTUPLE LPAREN expr RPAREN
#line 367 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::istuple, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1589 "Parser.cc"
    break;

  case 82: // primary_expr: ISARRAY LPAREN expr RPAREN
#line 369 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::isarray, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1595 "Parser.cc"
    break;

  case 83: // primary_expr: EXP LPAREN expr RPAREN
#line 371 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::exp, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1601 "Parser.cc"
    break;

  case 84: // primary_expr: LOG LPAREN expr RPAREN
#line 373 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::ln, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1607 "Parser.cc"
    break;

  case 85: // primary_expr: LN LPAREN expr RPAREN
#line 375 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::ln, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1613 "Parser.cc"
    break;

  case 86: // primary_expr: LOG10 LPAREN expr RPAREN
#line 377 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::log10, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1619 "Parser.cc"
    break;

  case 87: // primary_expr: SIN LPAREN expr RPAREN
#line 379 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::sin, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1625 "Parser.cc"
    break;

  case 88: // primary_expr: COS LPAREN expr RPAREN
#line 381 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cos, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1631 "Parser.cc"
    break;

  case 89: // primary_expr: TAN LPAREN expr RPAREN
#line 383 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::tan, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1637 "Parser.cc"
    break;

  case 90: // primary_expr: ASIN LPAREN expr RPAREN
#line 385 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::asin, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1643 "Parser.cc"
    break;

  case 91: // primary_expr: ACOS LPAREN expr RPAREN
#line 387 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::acos, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1649 "Parser.cc"
    break;

  case 92: // primary_expr: ATAN LPAREN expr RPAREN
#line 389 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::atan, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1655 "Parser.cc"
    break;

  case 93: // primary_expr: SQRT LPAREN expr RPAREN
#line 391 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::sqrt, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1661 "Parser.cc"
    break;

  case 94: // primary_expr: CBRT LPAREN expr RPAREN
#line 393 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cbrt, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1667 "Parser.cc"
    break;

  case 95: // primary_expr: SIGN LPAREN expr RPAREN
#line 395 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::sign, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1673 "Parser.cc"
    break;

  case 96: // primary_expr: FLOOR LPAREN expr RPAREN
#line 397 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::floor, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1679 "Parser.cc"
    break;

  case 97: // primary_expr: CEIL LPAREN expr RPAREN
#line 399 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::ceil, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1685 "Parser.cc"
    break;

  case 98: // primary_expr: TRUNC LPAREN expr RPAREN
#line 401 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::trunc, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1691 "Parser.cc"
    break;

  case 99: // primary_expr: SUM LPAREN expr RPAREN
#line 403 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::sum, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1697 "Parser.cc"
    break;

  case 100: // primary_expr: ERF LPAREN expr RPAREN
#line 405 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::erf, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1703 "Parser.cc"
    break;

  case 101: // primary_expr: ERFC LPAREN expr RPAREN
#line 407 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::erfc, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1709 "Parser.cc"
    break;

  case 102: // primary_expr: GAMMA LPAREN expr RPAREN
#line 409 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::gamma, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1715 "Parser.cc"
    break;

  case 103: // primary_expr: LGAMMA LPAREN expr RPAREN
#line 411 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::lgamma, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1721 "Parser.cc"
    break;

  case 104: // primary_expr: ROUND LPAREN expr RPAREN
#line 413 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::round, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1727 "Parser.cc"
    break;

  case 105: // primary_expr: NORMPDF LPAREN expr RPAREN
#line 415 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::normpdf, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1733 "Parser.cc"
    break;

  case 106: // primary_expr: NORMCDF LPAREN expr RPAREN
#line 417 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::normcdf, yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1739 "Parser.cc"
    break;

  case 107: // primary_expr: MAX LPAREN expr COMMA expr RPAREN
#line 419 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::max, yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1745 "Parser.cc"
    break;

  case 108: // primary_expr: MIN LPAREN expr COMMA expr RPAREN
#line 421 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::min, yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1751 "Parser.cc"
    break;

  case 109: // primary_expr: MOD LPAREN expr COMMA expr RPAREN
#line 423 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::mod, yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1757 "Parser.cc"
    break;

  case 110: // primary_expr: NORMPDF LPAREN expr COMMA expr COMMA expr RPAREN
#line 425 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<TrinaryOp>(codes::TrinaryOp::normpdf, yystack_[5].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1763 "Parser.cc"
    break;

  case 111: // primary_expr: NORMCDF LPAREN expr COMMA expr COMMA expr RPAREN
#line 427 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<TrinaryOp>(codes::TrinaryOp::normcdf, yystack_[5].value.as < ExpressionPtr > (), yystack_[3].value.as < ExpressionPtr > (), yystack_[1].value.as < ExpressionPtr > (), yylhs.location); }
#line 1769 "Parser.cc"
    break;

  case 112: // primary_expr: DEFINED LPAREN NAME RPAREN
#line 429 "Parser.yy"
               { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::defined, make_shared<String>(yystack_[1].value.as < string > (), yystack_[1].location), yylhs.location); }
#line 1775 "Parser.cc"
    break;

  case 113: // oper_expr: primary_expr
#line 432 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = yystack_[0].value.as < ExpressionPtr > (); }
#line 1781 "Parser.cc"
    break;

  case 114: // oper_expr: LPAREN BOOL RPAREN oper_expr
#line 434 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cast_bool, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1787 "Parser.cc"
    break;

  case 115: // oper_expr: LPAREN REAL RPAREN oper_expr
#line 436 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cast_real, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1793 "Parser.cc"
    break;

  case 116: // oper_expr: LPAREN STRING RPAREN oper_expr
#line 438 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cast_string, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1799 "Parser.cc"
    break;

  case 117: // oper_expr: LPAREN TUPLE RPAREN oper_expr
#line 440 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cast_tuple, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1805 "Parser.cc"
    break;

  case 118: // oper_expr: LPAREN ARRAY RPAREN oper_expr
#line 442 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::cast_array, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1811 "Parser.cc"
    break;

  case 119: // oper_expr: NOT oper_expr
#line 444 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::logical_not, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1817 "Parser.cc"
    break;

  case 120: // oper_expr: MINUS oper_expr
#line 446 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::unary_minus, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1823 "Parser.cc"
    break;

  case 121: // oper_expr: PLUS oper_expr
#line 448 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<UnaryOp>(codes::UnaryOp::unary_plus, yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1829 "Parser.cc"
    break;

  case 122: // oper_expr: oper_expr PLUS oper_expr
#line 450 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::plus, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1835 "Parser.cc"
    break;

  case 123: // oper_expr: oper_expr MINUS oper_expr
#line 452 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::minus, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1841 "Parser.cc"
    break;

  case 124: // oper_expr: oper_expr TIMES oper_expr
#line 454 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::times, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1847 "Parser.cc"
    break;

  case 125: // oper_expr: oper_expr DIVIDE oper_expr
#line 456 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::divide, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1853 "Parser.cc"
    break;

  case 126: // oper_expr: oper_expr POWER oper_expr
#line 458 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::power, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1859 "Parser.cc"
    break;

  case 127: // oper_expr: oper_expr UNION oper_expr
#line 460 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::set_union, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1865 "Parser.cc"
    break;

  case 128: // oper_expr: oper_expr INTERSECTION oper_expr
#line 462 "Parser.yy"
            { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::set_intersection, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1871 "Parser.cc"
    break;

  case 129: // colon_expr: oper_expr COLON oper_expr
#line 466 "Parser.yy"
             { yylhs.value.as < ExpressionPtr > () = make_shared<Range>(yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1877 "Parser.cc"
    break;

  case 130: // colon_expr: oper_expr COLON oper_expr COLON oper_expr
#line 468 "Parser.yy"
             { yylhs.value.as < ExpressionPtr > () = make_shared<Range>(yystack_[4].value.as < ExpressionPtr > (), yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1883 "Parser.cc"
    break;

  case 131: // expr: oper_expr
#line 471 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = yystack_[0].value.as < ExpressionPtr > (); }
#line 1889 "Parser.cc"
    break;

  case 132: // expr: colon_expr
#line 472 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = yystack_[0].value.as < ExpressionPtr > (); }
#line 1895 "Parser.cc"
    break;

  case 133: // expr: expr EQUAL_EQUAL expr
#line 474 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::equal_equal, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1901 "Parser.cc"
    break;

  case 134: // expr: expr NOT_EQUAL expr
#line 476 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::not_equal, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1907 "Parser.cc"
    break;

  case 135: // expr: expr LESS expr
#line 478 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::less, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1913 "Parser.cc"
    break;

  case 136: // expr: expr GREATER expr
#line 480 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::greater, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1919 "Parser.cc"
    break;

  case 137: // expr: expr LESS_EQUAL expr
#line 482 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::less_equal, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1925 "Parser.cc"
    break;

  case 138: // expr: expr GREATER_EQUAL expr
#line 484 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::greater_equal, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1931 "Parser.cc"
    break;

  case 139: // expr: expr AND expr
#line 486 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::logical_and, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1937 "Parser.cc"
    break;

  case 140: // expr: expr OR expr
#line 488 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::logical_or, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1943 "Parser.cc"
    break;

  case 141: // expr: expr IN expr
#line 490 "Parser.yy"
       { yylhs.value.as < ExpressionPtr > () = make_shared<BinaryOp>(codes::BinaryOp::in, yystack_[2].value.as < ExpressionPtr > (), yystack_[0].value.as < ExpressionPtr > (), yylhs.location); }
#line 1949 "Parser.cc"
    break;


#line 1953 "Parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -170;

  const signed char parser::yytable_ninf_ = -28;

  const short
  parser::yypact_[] =
  {
     215,  -170,  -170,  -170,  -170,   373,   373,   -16,   373,   373,
     373,    -2,   -40,  -170,  -170,    48,  -170,  -170,    -4,    57,
    -170,  -170,  -170,  -170,  -170,  -170,   373,   373,   373,   373,
    -170,  -170,   309,   373,    72,   132,   145,   152,   154,   163,
     164,   166,   168,   170,   178,   179,   186,   189,   203,   204,
     205,   206,   207,   211,   214,   216,   217,   218,   219,   221,
     223,   225,   229,   256,   257,   258,   259,   260,   265,   373,
     373,   373,     9,  -170,  -170,  -170,  -170,   494,  -170,   910,
     910,   266,   185,   231,   910,   910,   988,   261,  -170,   200,
     142,  -170,  -170,  -170,  -170,   997,   277,     1,   -38,   281,
     282,   272,   274,   287,   289,   290,    28,   181,   -11,     8,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   224,   226,   226,   226,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   373,
     373,   373,   373,   373,   373,   373,   373,   -14,   373,   373,
    -170,   297,  -170,  -170,   373,  -170,  -170,  -170,   373,  -170,
     228,  -170,   215,  -170,  -170,   373,   373,   373,   373,   373,
     373,  -170,   373,  -170,   373,  -170,   373,   373,   463,   476,
     493,   521,   534,   551,   560,   569,   579,   592,   627,   637,
     650,   197,   375,   659,   668,   685,   695,   435,   726,   743,
     753,   762,   771,   227,   418,   784,   801,   829,   842,   859,
     868,   877,   302,    70,   910,   148,   593,   -59,   -25,   -17,
     -17,   226,   226,   235,    26,   188,    71,    71,   247,   247,
     247,   247,   248,  -170,  -170,  -170,   149,   910,   910,   238,
      -7,   404,   215,   215,   226,   226,   226,   226,   226,   910,
     910,   910,  1006,    -8,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,   373,   373,  -170,
    -170,  -170,  -170,   373,  -170,  -170,  -170,  -170,  -170,   373,
    -170,   373,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,   373,   240,  -170,   200,   373,   241,   215,
     215,   373,   373,   887,   900,   935,   445,   454,   -39,  -170,
     910,   215,   215,    -9,   967,  -170,  -170,  -170,   373,   373,
     190,  -170,   373,  -170,   945,   958,  -170,   976,  -170,  -170,
    -170
  };

  const unsigned char
  parser::yydefact_[] =
  {
       0,    29,    31,    33,    35,     0,     0,     0,     0,     0,
       0,    16,     0,    48,    49,     0,     2,     4,     0,     0,
      23,    24,    25,    26,     5,     6,     0,     0,     0,     0,
      67,    68,    59,    56,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    51,    70,    69,    64,   113,   131,   132,     9,
      10,    51,    11,     0,    14,    15,     0,     0,    21,    17,
       0,     1,     3,     7,     8,     0,     0,    37,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   121,   120,   119,    56,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,    22,    20,     0,    32,    42,    45,     0,    41,
       0,    38,    39,    34,    36,     0,     0,     0,     0,     0,
       0,    72,    60,    63,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    57,     0,   129,   127,   128,   122,
     123,   124,   125,   126,   140,   139,   133,   134,   135,   136,
     137,   138,   141,    52,    51,    54,     0,    12,    13,    18,
     141,     0,    46,    40,   114,   115,   116,   117,   118,    62,
      61,    58,     0,   141,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,     0,     0,    96,
      97,    98,    99,     0,   100,   101,   102,   103,   104,     0,
     105,     0,   106,    76,    77,    78,    79,    80,    81,    82,
     112,    66,    65,     0,     0,    53,    19,     0,     0,    43,
      47,     0,     0,     0,     0,     0,     0,     0,   130,    55,
      28,     0,    44,   141,     0,   107,   108,   109,     0,     0,
       0,    74,     0,    73,     0,     0,    30,     0,   110,   111,
      75
  };

  const short
  parser::yypgoto_[] =
  {
    -170,  -169,   -13,  -170,  -170,    73,  -170,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,  -170,   112,  -170,  -170,  -170,
    -170,  -170,  -170,  -170,    -1,  -170,  -170,  -129,  -170,  -170,
      25,  -170,    -5
  };

  const short
  parser::yydefgoto_[] =
  {
       0,    15,    16,    17,    18,    89,    19,   318,    20,    26,
      21,    27,    22,    28,    23,    29,    96,    97,   178,   179,
     180,   181,    24,    25,    75,    83,   256,   108,   106,    76,
      77,    78,    98
  };

  const short
  parser::yytable_[] =
  {
      79,    80,    92,    84,    85,    86,    82,   253,   194,   176,
     177,   196,   195,   263,   341,   342,   322,   317,    87,   233,
     235,    95,   152,   153,   154,   155,   156,   107,   109,   148,
     157,   149,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   151,   152,   153,   154,   155,   156,   190,    91,   191,
     157,     1,    90,     2,     3,     4,   182,   153,   154,   155,
     156,     5,     6,     7,   157,     8,     9,   155,   156,   -28,
     -28,   -28,   157,    10,    81,    11,   254,    12,   158,   159,
     160,   161,   162,   163,   164,   165,   197,   -27,    88,   194,
      93,   311,   110,   320,   145,   146,   147,   159,   160,   161,
     162,   163,   164,   165,   166,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    13,
      99,   100,    14,   234,   234,   162,   163,   164,   165,   166,
     332,    94,   111,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   340,   257,   258,   112,   255,   194,   314,   260,
     315,   312,   113,   261,   114,   236,   237,   238,   239,   240,
     241,   242,   243,   115,   116,   269,   117,   270,   118,   271,
     119,   272,   273,     1,   346,     2,     3,     4,   120,   121,
     192,   168,   193,     5,     6,     7,   122,     8,     9,   123,
     264,   265,   266,   267,   268,    10,   287,    11,     1,    12,
       2,     3,     4,   124,   125,   126,   127,   128,     5,     6,
       7,   129,     8,     9,   130,   173,   131,   132,   133,   134,
      10,   135,    11,   136,    12,   137,   299,   169,   300,   138,
      92,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     160,   161,   162,   163,   164,   165,   166,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   139,   140,   141,   142,
     143,    13,   323,   324,    14,   144,   167,   175,   325,   171,
     172,   183,   184,   185,   326,   186,   327,   158,   159,   160,
     161,   162,   163,   164,   165,   166,    13,    92,   187,    14,
     188,   189,   330,   329,   232,   157,   333,   334,   259,    92,
      30,    31,   262,   310,   -28,   166,   -28,    92,    88,    32,
     254,    33,   316,   344,   345,   331,     0,   347,   328,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,   101,   102,   103,   104,   105,    68,     0,
       0,     0,     0,     0,    30,    31,     0,     0,     0,     0,
       0,    69,    70,    32,   288,    33,    71,     0,     0,    72,
       0,    73,    74,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,   301,     0,   302,
       0,     0,    68,     0,     0,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   293,    69,    70,     0,     0,     0,
      71,     0,     0,    72,   338,    73,    74,     0,     0,     0,
       0,     0,     0,   339,   158,   159,   160,   161,   162,   163,
     164,   165,   166,     0,   274,     0,     0,     0,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   275,   319,     0,
       0,     0,     0,     0,     0,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   276,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   277,     0,     0,     0,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   278,     0,     0,     0,     0,
       0,     0,     0,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   279,   150,   151,   152,   153,   154,   155,   156,
       0,   280,     0,   157,     0,     0,     0,     0,     0,     0,
     281,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     282,     0,     0,     0,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   283,     0,     0,     0,     0,     0,     0,
       0,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   284,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   285,     0,
       0,     0,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   286,   313,   151,   152,   153,   154,   155,   156,     0,
     289,     0,   157,     0,     0,     0,     0,     0,     0,   290,
       0,     0,     0,     0,     0,     0,     0,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   291,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   292,     0,     0,     0,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   294,     0,     0,
       0,     0,     0,     0,     0,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   295,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   296,     0,     0,     0,     0,     0,
       0,     0,     0,   297,     0,     0,     0,     0,     0,     0,
       0,     0,   298,     0,     0,     0,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   303,     0,     0,     0,     0,
       0,     0,     0,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   304,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     305,     0,     0,     0,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   306,     0,     0,     0,     0,     0,     0,
       0,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     307,     0,     0,     0,     0,     0,     0,     0,     0,   308,
       0,     0,     0,     0,     0,     0,     0,     0,   309,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   335,     0,
       0,     0,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   336,     0,     0,     0,     0,     0,     0,     0,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   337,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   348,     0,     0,     0,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   349,
     158,   159,   160,   161,   162,   163,   164,   165,   166,     0,
     343,     0,     0,     0,     0,     0,     0,     0,     0,   350,
       0,     0,     0,     0,     0,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   170,   158,   159,   160,   161,   162,
     163,   164,   165,   166,     0,     0,     0,     0,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   158,   159,   160,   161,
     162,   163,   164,   165,   166,     0,     0,     0,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   158,   159,   160,
     161,   162,   163,   164,   165,   174,   158,   159,   160,   161,
     162,   163,   164,   165,   321
  };

  const short
  parser::yycheck_[] =
  {
       5,     6,    15,     8,     9,    10,     7,    21,    19,     8,
       9,     3,    23,   182,    23,    24,    24,    24,    20,   148,
     149,    26,    81,    82,    83,    84,    85,    32,    33,    20,
      89,    22,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    80,    81,    82,    83,    84,    85,    19,     0,    21,
      89,     3,    92,     5,     6,     7,    94,    82,    83,    84,
      85,    13,    14,    15,    89,    17,    18,    84,    85,    78,
      78,    78,    89,    25,    90,    27,    90,    29,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    94,    90,    19,
      94,    21,    20,   262,    69,    70,    71,    71,    72,    73,
      74,    75,    76,    77,    78,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,    91,
      28,    29,    94,   148,   149,    74,    75,    76,    77,    78,
     319,    94,    20,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   331,   168,   169,    20,   167,    19,    19,   174,
      21,    23,    20,   178,    20,   150,   151,   152,   153,   154,
     155,   156,   157,    20,    20,   190,    20,   192,    20,   194,
      20,   196,   197,     3,     4,     5,     6,     7,    20,    20,
      19,    16,    21,    13,    14,    15,    20,    17,    18,    20,
     185,   186,   187,   188,   189,    25,    19,    27,     3,    29,
       5,     6,     7,    20,    20,    20,    20,    20,    13,    14,
      15,    20,    17,    18,    20,    93,    20,    20,    20,    20,
      25,    20,    27,    20,    29,    20,    19,    16,    21,    20,
     263,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      72,    73,    74,    75,    76,    77,    78,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    20,    20,    20,    20,
      20,    91,   287,   288,    94,    20,    20,    10,   293,    28,
      90,    10,    10,    21,   299,    21,   301,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    91,   320,    21,    94,
      21,    21,   317,   314,    90,    89,   321,   322,    21,   332,
      11,    12,    94,    21,    89,    78,    78,   340,    90,    20,
      90,    22,   259,   338,   339,    94,    -1,   342,   313,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,    -1,
      -1,    82,    83,    20,    19,    22,    87,    -1,    -1,    90,
      -1,    92,    93,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    19,    -1,    21,
      -1,    -1,    69,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    19,    82,    83,    -1,    -1,    -1,
      87,    -1,    -1,    90,    19,    92,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    21,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    21,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    21,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    21,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    21,    79,    80,    81,    82,    83,    84,    85,
      -1,    21,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      21,    -1,    -1,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    21,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    21,    -1,
      -1,    -1,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    21,    79,    80,    81,    82,    83,    84,    85,    -1,
      21,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    21,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    21,    -1,    -1,    -1,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    21,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    -1,    -1,    -1,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    21,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      21,    -1,    -1,    -1,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    21,    -1,
      -1,    -1,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    21,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    21,    -1,    -1,    -1,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    21,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    26,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    -1,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    -1,    -1,    -1,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    70,    71,    72,    73,
      74,    75,    76,    77,    78
  };

  const signed char
  parser::yystos_[] =
  {
       0,     3,     5,     6,     7,    13,    14,    15,    17,    18,
      25,    27,    29,    91,    94,    96,    97,    98,    99,   101,
     103,   105,   107,   109,   117,   118,   104,   106,   108,   110,
      11,    12,    20,    22,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    69,    82,
      83,    87,    90,    92,    93,   119,   124,   125,   126,   127,
     127,    90,   119,   120,   127,   127,   127,    20,    90,   100,
      92,     0,    97,    94,    94,   127,   111,   112,   127,   111,
     111,    64,    65,    66,    67,    68,   123,   127,   122,   127,
      20,    20,    20,    20,    20,    20,    20,    20,    20,    20,
      20,    20,    20,    20,    20,    20,    20,    20,    20,    20,
      20,    20,    20,    20,    20,    20,    20,    20,    20,    20,
      20,    20,    20,    20,    20,   125,   125,   125,    20,    22,
      79,    80,    81,    82,    83,    84,    85,    89,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    20,    16,    16,
      26,    28,    90,    93,    78,    10,     8,     9,   113,   114,
     115,   116,    94,    10,    10,    21,    21,    21,    21,    21,
      19,    21,    19,    21,    19,    23,     3,    78,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,    90,   122,   127,   122,   125,   125,   125,   125,
     125,   125,   125,   125,   127,   127,   127,   127,   127,   127,
     127,   127,   127,    21,    90,   119,   121,   127,   127,    21,
     127,   127,    94,    96,   125,   125,   125,   125,   125,   127,
     127,   127,   127,   127,    21,    21,    21,    21,    21,    21,
      21,    21,    21,    21,    21,    21,    21,    19,    19,    21,
      21,    21,    21,    19,    21,    21,    21,    21,    21,    19,
      21,    19,    21,    21,    21,    21,    21,    21,    21,    21,
      21,    21,    23,    79,    19,    21,   100,    24,   102,    94,
      96,    78,    24,   127,   127,   127,   127,   127,   125,   119,
     127,    94,    96,   127,   127,    21,    21,    21,    19,    19,
      96,    23,    24,    23,   127,   127,     4,   127,    21,    21,
      23
  };

  const signed char
  parser::yyr1_[] =
  {
       0,    95,    96,    96,    97,    97,    97,    98,    98,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,   100,   100,   101,   101,   101,   101,   102,   102,   104,
     103,   106,   105,   108,   107,   110,   109,   111,   111,   112,
     112,   112,   113,   114,   114,   115,   116,   116,   117,   117,
     118,   119,   120,   120,   121,   121,   122,   122,   122,   123,
     123,   123,   123,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   125,   125,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   126,
     126,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     2,     2,     2,
       2,     2,     4,     4,     2,     2,     1,     2,     4,     5,
       3,     1,     2,     1,     1,     1,     1,     0,     2,     0,
       9,     0,     4,     0,     4,     0,     4,     1,     2,     2,
       3,     2,     1,     3,     4,     1,     2,     3,     1,     1,
       3,     1,     3,     4,     1,     3,     0,     1,     3,     0,
       2,     3,     3,     3,     1,     4,     4,     1,     1,     1,
       1,     3,     3,     7,     7,     9,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     6,     6,     6,
       8,     8,     4,     1,     4,     4,     4,     4,     4,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "FOR", "ENDFOR", "IF",
  "IFDEF", "IFNDEF", "ELSEIF", "ELSE", "ENDIF", "TRUE", "FALSE", "INCLUDE",
  "INCLUDEPATH", "DEFINE", "EQUAL", "D_ECHO", "ERROR", "COMMA", "LPAREN",
  "RPAREN", "LBRACKET", "RBRACKET", "WHEN", "BEGIN_EVAL", "END_EVAL",
  "ECHOMACROVARS", "SAVE", "LINE", "EXP", "LOG", "LN", "LOG10", "SIN",
  "COS", "TAN", "ASIN", "ACOS", "ATAN", "SQRT", "CBRT", "SIGN", "MAX",
  "MIN", "FLOOR", "CEIL", "TRUNC", "SUM", "MOD", "ERF", "ERFC", "GAMMA",
  "LGAMMA", "ROUND", "NORMPDF", "NORMCDF", "LENGTH", "ISEMPTY",
  "ISBOOLEAN", "ISREAL", "ISSTRING", "ISTUPLE", "ISARRAY", "BOOL", "REAL",
  "STRING", "TUPLE", "ARRAY", "DEFINED", "OR", "AND", "EQUAL_EQUAL",
  "NOT_EQUAL", "LESS", "GREATER", "LESS_EQUAL", "GREATER_EQUAL", "IN",
  "COLON", "UNION", "INTERSECTION", "PLUS", "MINUS", "TIMES", "DIVIDE",
  "UNARY", "NOT", "CAST", "POWER", "NAME", "TEXT", "QUOTED_STRING",
  "NUMBER", "EOL", "$accept", "statements", "statement", "directive",
  "directive_one_line", "name_list", "directive_multiline", "for_when",
  "for", "$@1", "if", "$@2", "ifdef", "$@3", "ifndef", "$@4", "if_list",
  "if_list1", "elseif_begin", "elseif", "else_begin", "else", "text",
  "eval", "symbol", "function", "function_args", "comma_expr",
  "tuple_comma_expr", "primary_expr", "oper_expr", "colon_expr", "expr", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   109,   109,   113,   119,   120,   121,   124,   125,   128,
     130,   132,   137,   139,   141,   143,   145,   147,   149,   151,
     153,   161,   163,   170,   171,   172,   173,   176,   178,   182,
     182,   213,   213,   217,   217,   221,   221,   225,   226,   233,
     239,   245,   252,   254,   260,   268,   270,   276,   284,   286,
     290,   294,   298,   300,   304,   306,   310,   312,   314,   318,
     320,   322,   324,   328,   330,   332,   336,   338,   340,   342,
     344,   346,   348,   350,   352,   354,   356,   358,   360,   362,
     364,   366,   368,   370,   372,   374,   376,   378,   380,   382,
     384,   386,   388,   390,   392,   394,   396,   398,   400,   402,
     404,   406,   408,   410,   412,   414,   416,   418,   420,   422,
     424,   426,   428,   432,   433,   435,   437,   439,   441,   443,
     445,   447,   449,   451,   453,   455,   457,   459,   461,   465,
     467,   471,   472,   473,   475,   477,   479,   481,   483,   485,
     487,   489
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94
    };
    // Last valid token kind.
    const int code_max = 349;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 25 "Parser.yy"
} // Tokenizer
#line 2851 "Parser.cc"

#line 493 "Parser.yy"


void
Tokenizer::parser::error(const Tokenizer::parser::location_type &l, const string &m)
{
  driver.error(l, m);
}
